# Josephus problem with Rank Tree

import sys

from ranktree import RankTree

def josephus(n, m): 
  if n > 26:
    a = [ str(i) for i in range(1, n+1) ]
  else:
    a = [ chr(ord('A') + i - 1) for i in range(1, n+1) ]
  r = RankTree(a)
  p = 0
  for i in range(1, n):
    if n <= 26:
      print(str(r) + " : " + r.find(p))
    p = (p + m) % len(r)
    r.remove(p)
    if p == len(r):
      p = 0
  return r.find(p)

result = josephus(int(sys.argv[1]), int(sys.argv[2]))
print("The last one is ", result)
